<?php
/**
 * Created by PhpStorm.
 * User: liqingyuan
 * Date: 2018/7/24
 * Time: 下午7:22
 */


class Constants
{

    /**
     * 基本常量定义
     */
    const SSO_LOGIN_CODE_APP_TYPE = 2;

    const CALLBACK_SIGN_KEY_19 = 'offcn!login_zaixiankt@)))user|(( md5';    // 19课堂回放 回调函数私有key
    const ENCRYPT_SALT = 'offcn!login_zliswe^@)))user|((@myufs';
    const SSO_LOGIN_SIGN_KEY = '9eaf618cca780358d7c98c00dc18e148';
    const ZXKT_VERIFY_KEY = '6dNIHASZwFpVOYl1Qib3G54x780hjfUkKzPuBcWToDEmtgqX9vaeCnrRyMsJ2L';
    const APPLE_COURSE_PREFIX = 'com.eoffcn.classonline.course';
    const MESSAGE_TOKEN='52cZSXuG8UFi8fR4HiE7DV7NhX3UehmsC8y91GBNbxB';


    /**
     * 基本错误类型
     */
    const SUCCESS = 0;    // 成功
    const FAIL = 1;    // 失败
    const FAIL_CODE = 1001;


    const COURSE_PLATFORM_OLD = 1;
    const COURSE_PLATFORM_NEW = 2;



    /**
     * 业务错误类型
     * 错错误码长度为 4 位
     * 不同业务请增加1000位
     * 如： -1001 和 -2001
     */
    const ERR_INFO_NOT_EXISTS = -1001;    // 信息不存在
    const ERR_USER_NOT_EXISTS = -1002;    // 用户不存在
    const ERR_EXCEPTION = -1003; //异常错误
    const ERR_USER_LOGIN_TIMEOUT = -1004;    // 用户登陆超时
    const ERR_INFO_SET_FAIL = -1005;    //  信息设置失败


    const ERR_PARAMS_NOT_VALIDATE = -2001;    // 参数不合法
    const ERR_REQUEST_NOT_VALIDATE = -2002;    // 访问不合法
    const ERR_REQUEST_TIMEOUT = -2003;    // 请求已过期
    const ERR_SIGN_INVALIDATE = -2004;    // 签名错误

    const ERR_RESULT_IS_EMPTY = -3001;    // 数据为空


    const ERR_JPUSH_REGISTER = -4001;    // 推送注册失败
    const ERR_JPUSH_LOGOUT = -4002;    // 推送登出失败

    const ERR_DOWNLOAD_RECORD_FAIL = -5001;    // 下载记录存储失败

    const ERR_IM_LOGIN = -6001;    // 融云登陆失败
    const ERR_IM_SEND_FAIL = -6002;    // 融云消息发送失败

    const ERR_FILE_UPLOAD_FAIL = -7001;    // 上传文件失败
    const ERR_FILE_IS_EMPTY = -7002;    // 上传文件不能为空

    const ERR_SELF_HELP_SAVE_FAIL = -8001;    // 自助开课失败
    const ERR_ClOSE_ORDER_FAIL = -8002;    // 关闭订单失败
    const ERR_SUBMIT_ADDRESS_FAIL = -8003;    // 提交地址失败
    const ERR_AUTH_ORDER_FAIL = -8004;    // 订单鉴权失败，请重试

    const ERR_STUDY_RECORD_FAIL = -9001;  //学习记录获取失败
    
    
    /**
     * curl code值定义
     */
    const CURL_REQUEST_ERROR = 20001; //curl请求失败
    const CURL_DATA_ERROR = 20002; //返回数据格式错误
    const CURL_EXCEPTION_ERROR = 20003; //curl请求异常code
    const ROUT_EXCEPTION_ERROR = 20004; //路由接口请求异常code
    
    
    const PARAMETER_INPUT_ERROR = 10001; //参数传入失败
    
    //redis缓存key
    const USER_COURSE_KEY = 'user_course_qiyi';
    
    //获取学习记录信息  app平台介入
    const APP_CLIENT_ID = 9;

    const APP_CLIENT_ID_SSO = 7;


    const IDENTITY_ZAIZHI = 1;
    const IDENTITY_DAIYE = 2;
    const IDENTITY_ZAIXIAOSHENG = 3;



    const STATUS_WAITING_POST_ORDER = 31;//代发货状态的订单


    const NEED_ADD_ADDRESS = 1;

    /**
     * @return array
     */
    public static function getIdentityName()
    {

        return array(
            self::IDENTITY_ZAIZHI => '在职',
            self::IDENTITY_DAIYE => '待业',
            self::IDENTITY_ZAIXIAOSHENG => '在校学生',
        );
    }

    /**
     * @return array
     */
    public static function getAppointmentStatusName()
    {

        return array(
            0 => '预约',
            1 => '撤销预约',
            2 => '已预约',
            3 => '已约满',
            4 => '预约'
        );
    }

    /**
     * @return array
     */
    public static function getIdentityNames()
    {

        return array(
            '在职' => self::IDENTITY_ZAIZHI,
            '待业' => self::IDENTITY_DAIYE,
            '在校学生'=> self::IDENTITY_ZAIXIAOSHENG,
        );
    }
    
    //请求 查询时间片段上安排的直播频道信息 返回的code对应的提示信息
    public static  $liveChannalCodes =
        array(
              0 => '成功',
            101 => '该时间段尚未预约课程',
            102 => '该时间段尚未分组安排',
            103 => '该时间段分组信息内容错误',
            );
    
    
    public static $liveDatesCodes = array(
        0=>'成功',
        101=>'该时段您已有课程预约，如调整内容请先取消预约',
        102=>'尝试取消该时间段上没有的预约信息',
        103=>'您约过同样的课程，请不要重复预约',
        104=>'个人信息不完善',
        105=>'课时不足，请购买课时',
        106=>'预约课程失败',
        109=>'截止取消预约',
        110=>'个人信息不完善',
        114=>'当前时间按已经截至预约',
        122=>'当前时间段预约量已满，请选择其他时间段预约',
    );
    /**
     * 错误消息响应
     */
    private static $_errMsg = [
        // 基础错误
        self::SUCCESS => ['成功', 'success'],
        self::FAIL => ['失败', 'fail'],

        self::ERR_INFO_NOT_EXISTS => ['信息不存在', 'info is not exist'],

        self::ERR_USER_NOT_EXISTS => ['用户不存在', 'user is not exist'],

        self::ERR_EXCEPTION => ['异常错误', 'exception err'],

        self::ERR_INFO_SET_FAIL => ['信息设置失败', 'user is not exist'],
        self::ERR_USER_LOGIN_TIMEOUT => ['用户登陆超时', 'user login timeout'],


        self::ERR_PARAMS_NOT_VALIDATE => ['参数不合法', 'params is not validate'],
        self::ERR_REQUEST_NOT_VALIDATE => ['访问不合法', 'request is not validate'],

        self::ERR_REQUEST_TIMEOUT => ['请求已过期, 请重试！', 'request is timeout'],
        self::ERR_SIGN_INVALIDATE => ['签名校验错误, 请重试！', 'sign is not validate'],
        
        self::ERR_RESULT_IS_EMPTY => ['数据为空', 'result is empty'],
        
        self::ERR_JPUSH_REGISTER => ['极光推送注册失败', 'jpush register fail'],
        self::ERR_JPUSH_LOGOUT => ['极光推送登出失败', 'jpush logout fail'],


        self::ERR_IM_LOGIN => ['融云登陆失败', 'rong_cloud login fail'],
        self::ERR_IM_SEND_FAIL => ['融云消息发送失败', 'rong_cloud send msg fail'],


        self::ERR_DOWNLOAD_RECORD_FAIL => ['下载记录存储失败', 'download record fail'],

        self::ERR_IM_LOGIN  => ['登陆IM失败', 'login rongyun im fial'],

        self::ERR_FILE_UPLOAD_FAIL => ['文件上传失败', 'file upload fail'],

        self::ERR_FILE_IS_EMPTY => ['上传文件不能为空', 'file upload is empty'],

        self::ERR_DOWNLOAD_RECORD_FAIL => ['下载记录存储失败', 'download record fail'],

        self::ERR_SELF_HELP_SAVE_FAIL => ['自助开课失败', 'self help save fail'],

        self::ERR_ClOSE_ORDER_FAIL => ['关闭订单失败', 'close order fail'],

        self::ERR_SUBMIT_ADDRESS_FAIL => ['提交地址失败', 'submit address fail'],

        self::ERR_AUTH_ORDER_FAIL => ['订单页面鉴权失败，请重试！', 'order h5 auth fail, try again later!'],

        self::ERR_STUDY_RECORD_FAIL => ['学习记录获取失败, 请重试！', 'study record fail']



        //其他业务请在下面对照写中英文错误信息

    ];

    public static function msg($errno, $lang = '')
    {
        $lang = empty($lang) ? config('app.locale'):$lang;
        $lang = 'zh_cn' === $lang ? 0 : 1;
        return self::$_errMsg[$errno][$lang] ?? '';
    }




    //图书邮寄常量定义
    //delivery_process 表 status
    const STATUS_UNSURE = 0; //备货中
    const STATUS_NOT_HAS_DELIVERY= 5; // 暂无图书邮寄信息
    const STATUS_PART_POST= 4; //部分发货
    const STATUS_WAITING_POST = 1; //备货中
    const STATUS_POST = 2; //已发货
    const STATUS_EXPORT = 3; //已导出


    //平台常量
    const PLATFORM_DEFAULT = 0;
    const PLATFORM_U_CLASS = 1;
    //数据是否有效
    const IS_DELETE = 1;//已删除
    const NOT_DELETE = 0;//合法数据

    //是否有需要继续申请的图书
    const HAS_DELIVERY = 1;
    const HAS_NOT_DELIVERY = 0;

    //是否有旧线订单
    const HAS_ORDER = 1;
    const HAS_NOT_ORDER = 0;

    //是否是默认地址
    const IS_DEFAULT = 1;
    const IS_NOT_DEFAULT = 0;


    const EXTRA_STATUS_PURE = 0; //课程下面的图书完全没有下过单
    const EXTRA_STATUS_POST = 1;//课程下面的图书全部被其他课程下过单
    const EXTRA_STATUS_PART_POST = 2; //课程下的图书 部分下过单


    const NOT_LOGIN = 9999;

    //7易接口返回的code码
    const NOT_BUY_COURSE = 2001;
    const NOT_HAS_BOOK_NUMBER = 3;

    const PRODUCT_NAME_SUFFIX = '  (1本)';



}
